import six
from six import BytesIO
from six.moves.urllib.parse import quote
from six.moves.urllib import parse as urllib
from six.moves.urllib_response import addinfourl
try:
    import urllib.request as urllib2
except ImportError:
    import urllib2
if six.PY3:
    from http import cookiejar as cookielib
else:
    import cookielib
import os,sys,re
if sys.version_info[0] > 2:
    unicode = str
import dodge #for khmertv
dodge = dodge.console  # for windows, andriod, & Rpi compatibility	
import base64
import requests
import xml.dom.minidom
import xbmcaddon,xbmcplugin,xbmcgui,xbmc,xbmcvfs
import json #For VIMEO
import os,string,gzip
from bs4 import BeautifulSoup
import resolveurl
from urllib.parse import urljoin

#Addon name
PLUGIN = xbmcaddon.Addon(id='plugin.video.KhmerDubbed')
addon_name = 'plugin.video.KhmerDubbed'

# List of site
PHUMIK = 'http://phumikhmer2.com/'
VIDEO4KHMER = 'https://www.video4khmer36.com/'

# use mode ==10
KHMERAVENUE = 'https://www.khmeravenue.com/'
MERLKON = 'http://www.khmerdrama.com/'
THEKOMSAN = 'http://www.thekomsan.com/'
CKH7 = 'http://www.ckh7.com/'
PHUMI8 = 'https://phumi8.com/'
TVSROKKHMER = 'https://www.tvsrokkhmer.com/'
K8MERS = 'https://www.k8mers.com/'
KHMER4 ='https://www.khmer4holiday.com/'

Icon = 'http://radio.js-cambodia.com/' #khmertv

USER_AGENT = "Mozilla/5.0 (Windows NT 6.2; Win64; x64; rv:16.0.1) Gecko/20121011 Firefox/16.0.1"
datapath = xbmcvfs.translatePath('special://profile/addon_data/'+addon_name)
cookiejar = os.path.join(datapath,'khmerstream.lwp')
ADDON_PATH = PLUGIN.getAddonInfo('path')
addon_name = PLUGIN.getAddonInfo('profile')
sys.path.append( os.path.join( ADDON_PATH, 'resources', 'lib' ) )

## khmertv
from t0mm0.common.addon import Addon
from t0mm0.common.net import Net
# khmer End

pluginhandle = int(sys.argv[1])
# path image
JolchetImage = os.path.join(ADDON_PATH, 'resources', 'images','icon.png')
SearchImage = os.path.join(ADDON_PATH, 'resources', 'images','search1.png')
UtubeImage = os.path.join(ADDON_PATH, 'resources', 'images','playlist.png')
fanart = os.path.join(ADDON_PATH, 'resources', 'images','Angkor4.jpg')
movie9Image = os.path.join(ADDON_PATH, 'resources', 'images','movie9.png')
khmertv1 = os.path.join(ADDON_PATH, 'resources', 'images','khmertv.png')

def OpenURL(url):
    req = urllib2.Request(url)
    req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/28.0.1500.72 Safari/537.3')
    response = urllib2.urlopen(req)
    link=response.read()
    response.close()
    return link 

def OpenSoup(url):
    req = urllib2.Request(url)
    req.add_unredirected_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:23.0) Gecko/20130406 Firefox/23.0')
    response = urllib2.urlopen(req).read()
    return response

# Keyboard	
def GetInput(strMessage,headtxt,ishidden):
    keyboard = xbmc.Keyboard("",strMessage,ishidden)
    keyboard.setHeading(headtxt) # optional
    keyboard.doModal()
    inputText=""
    if (keyboard.isConfirmed()):
        inputText = keyboard.getText()
    del keyboard
    return inputText
# Keyboard end script	


def HOME():
		addDir("[COLOR yellow][B][I]SEARCH[/I][/B][/COLOR]",MERLKON,5,SearchImage+'')
		addDir('Khmer Live TV',Icon,11,khmertv1) 		
		addDir('============= [COLOR red] THAI DRAMA [/COLOR] =============',"",21,'https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcRqmBo9csU8og2IfxEwW2HF-cU2J_98dYW3EQ&usqp=CAU')
		addDir('Thai Spoken',KHMER4+'search/label/Thai%20Original?&max-results=24',101,'https://play-lh.googleusercontent.com/-cI2O2Y4cQ9XLMXHozpU4vMki4jSBXozs3iU71T8-0xu94n6c4covpVAODb5Lm513w=w240-h480-rw')  		
		addDir('THAI',K8MERS,81,'https://1.bp.blogspot.com/-ZZGR_FPpJcA/YB13ZgCrq2I/AAAAAAAAAwQ/Ly1kboW2hlI8dDG-UqL5b0PTuMedCS1FgCK4BGAYYCw/s368/Merl7-logo.png')  		
		addDir('Lakorn',PHUMI8+'category/thai-lakorn/',61,'https://1.bp.blogspot.com/-gxS_ldES0Zo/Xu2qHAfLjwI/AAAAAAAAEiw/dsIO7S8xLhk8b1vFHoerUZ0Uo_y6kir1wCK4BGAsYHg/s600/p8.png')   	
		addDir('Thai',TVSROKKHMER+'search/label/Thai%20Drama?&max-results=20',71,'https://blogger.googleusercontent.com/img/a/AVvXsEg3q7_iwiIc5f4drcfWe_tsXSHVvPHxDVBWhC0lhtvvk5y5STbLf-VU6iotV6PTIMgVZSEGKow7gBck7FvBamrnZaeJkexNegxEcz9TY0yOeRmKfbyxH83trKbkB2jOx_08xgOG96PPmn7XAEJs4YZuafBP2ALgJYa1bEw2phAHm3PQOeGMAfdFfdR4Dg=s630') 

		addDir('============= [COLOR red] KHMERAVENUE [/COLOR] =============',"",21,'http://www.khmeravenue.com/wp-contents/uploads/logo.jpg')
		addDir('China',KHMERAVENUE+'country/china/',21,'http://www.khmeravenue.com/wp-contents/uploads/logo.jpg')
		addDir('HK',KHMERAVENUE+'country/hong-kong/',21,'http://www.khmeravenue.com/wp-contents/uploads/logo.jpg')
		addDir('Ancient',KHMERAVENUE+'genre/ancient/',21,'http://www.khmeravenue.com/wp-contents/uploads/logo.jpg')
		addDir('Modern',KHMERAVENUE+'genre/modern/',21,'http://www.khmeravenue.com/wp-contents/uploads/logo.jpg')
		addDir('Korean',KHMERAVENUE+'country/korea/',21,'http://www.khmeravenue.com/wp-contents/uploads/logo.jpg')
		addDir('Movies',KHMERAVENUE+'albumcategory/kon/',21,'http://www.khmeravenue.com/wp-contents/uploads/logo.jpg')		
		addDir('============= [COLOR red] MERLKON [/COLOR] =============',"",21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')		
		addDir('Thai HD',MERLKON+'feature/hd-videos/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')
		addDir('Thai Boran',MERLKON+'genre/thai-boran/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')
		addDir('Thai Horror',MERLKON+'genre/horror/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')
		addDir('Thai Mayura',MERLKON+'dubbed/mayura/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')
		addDir('Thai KM',MERLKON+'dubbed/km/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')
		addDir('Indian',MERLKON+'country/India/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')	
		addDir('Philippines',MERLKON+'country/philippines/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')		
		addDir('Cambodia',MERLKON+'country/cambodia/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')			
		addDir('Kon',MERLKON+'albumcategory/kon/',21,'http://www.khmerdrama.com/wp-content/themes/avenue/img/logo.png')
		addDir('============= [COLOR red] VIDEO4KHMER [/COLOR] =============',"",31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')	
		addDir('Cambodia',VIDEO4KHMER+'khmer-movie-category/khmer-drama-watch-online-free-catalogue-504-page-1.html',31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')			
		addDir('Chinese Aired',VIDEO4KHMER+'khmer-movie-category/chinese-series-drama-to-be-continued-catalogue-2673-page-1.html',31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')		
		addDir('Chinese Completed',VIDEO4KHMER+'khmer-movie-category/chinese-series-drama-watch-online-free-catalogue-506-page-1.html',31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')		
		addDir('Thai Aired',VIDEO4KHMER+'khmer-movie-category/thai-lakorn-drama-to-be-continued-catalogue-2674-page-1.html',31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')		
		addDir('Thai Completed',VIDEO4KHMER+'khmer-movie-category/thai-lakorn-drama-watch-online-free-catalogue-537-page-1.html',31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')		
		addDir('Korean Aired',VIDEO4KHMER+'khmer-movie-category/korean-drama-to-be-continued-catalogue-508-page-1.html',31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')		
		addDir('Korean Completed',VIDEO4KHMER+'khmer-movie-category/korean-drama-watch-online-free-catalogue-507-page-1.html',31,'https://www.video4khmer36.com/templates/pkakrovan/images/all/logo.png')	
		addDir('============= [COLOR red] PHUMIKHMER2 [/COLOR] =============',"",91,'http://phumikhmer2.com/web/images/logo1.png')			
		addDir('Khmer',PHUMIK+'?tv=khmer-movie',91,'http://phumikhmer2.com/web/images/logo1.png')
		addDir('Thai',PHUMIK+'?tv=thai-drama',91,'http://phumikhmer2.com/web/images/logo1.png')
		addDir('Chinese',PHUMIK+'?tv=chinese-drama',91,'http://phumikhmer2.com/web/images/logo1.png')
		addDir('Korean',PHUMIK+'?tv=korean-drama',91,'http://phumikhmer2.com/web/images/logo1.png')
		addDir('Movies',PHUMIK+'?tv=thai-movie',91,'http://phumikhmer2.com/web/images/logo1.png')		
		addDir('============= [COLOR red] THEKOMSAN [/COLOR] =============',"",41,'http://www.thekomsan.com/templates/default/img/the-komsan-logo.png')			
		addDir('Currently Aired',THEKOMSAN+'category.php?cat=on-air',41,'http://www.thekomsan.com/templates/default/img/the-komsan-logo.png')
		addDir('Khmer',THEKOMSAN+'category.php?cat=khmer',41,'http://www.thekomsan.com/templates/default/img/the-komsan-logo.png')
		addDir('Thai',THEKOMSAN+'category.php?cat=thai',41,'http://www.thekomsan.com/templates/default/img/the-komsan-logo.png')
		addDir('Chinese',THEKOMSAN+'category.php?cat=chinese',41,'http://www.thekomsan.com/templates/default/img/the-komsan-logo.png')
		addDir('Korean',THEKOMSAN+'category.php?cat=korean',41,'http://www.thekomsan.com/templates/default/img/the-komsan-logo.png')		
		addDir('============= [COLOR red] CKH7 [/COLOR] =============',"",51,'http://www.ckh7.com/uploads/custom-logo.png')	
		addDir('Currently Aired',CKH7+'category.php?cat=on-air',51,'http://www.ckh7.com/uploads/custom-logo.png')			
		addDir('Khmer',CKH7+'category.php?cat=khmer-drama',51,'http://www.ckh7.com/uploads/custom-logo.png')	
		addDir('Thai',CKH7+'category.php?cat=thai-drama',51,'http://www.ckh7.com/uploads/custom-logo.png')	
		addDir('Chinese',CKH7+'category.php?cat=chinese-drama',51,'http://www.ckh7.com/uploads/custom-logo.png')			
		addDir('============= [COLOR red] KHMER4HOLIDAY [/COLOR] =============',"",101,'https://1.bp.blogspot.com/-9Y8PknwGtEE/YVp_qF4rR-I/AAAAAAAABAg/k4IED_8_o34L--XjAoMYZ6SwCKQgMZJkwCLcBGAsYHQ/s754/Khmer4Holiday.png')			
		addDir('Currently Aired',KHMER4+'search/label/Continue?&max-results=24',101,'https://1.bp.blogspot.com/-9Y8PknwGtEE/YVp_qF4rR-I/AAAAAAAABAg/k4IED_8_o34L--XjAoMYZ6SwCKQgMZJkwCLcBGAsYHQ/s754/Khmer4Holiday.png')
		addDir('Khmer',KHMER4+'search/label/Khmer%20Drama?&max-results=24',101,'https://1.bp.blogspot.com/-9Y8PknwGtEE/YVp_qF4rR-I/AAAAAAAABAg/k4IED_8_o34L--XjAoMYZ6SwCKQgMZJkwCLcBGAsYHQ/s754/Khmer4Holiday.png')
		addDir('Thai',KHMER4+'search/label/Thai%20Drama?&max-results=24',101,'https://1.bp.blogspot.com/-9Y8PknwGtEE/YVp_qF4rR-I/AAAAAAAABAg/k4IED_8_o34L--XjAoMYZ6SwCKQgMZJkwCLcBGAsYHQ/s754/Khmer4Holiday.png')
		addDir('Chinese',KHMER4+'search/label/Chines%20Drama?&max-results=24',101,'https://1.bp.blogspot.com/-9Y8PknwGtEE/YVp_qF4rR-I/AAAAAAAABAg/k4IED_8_o34L--XjAoMYZ6SwCKQgMZJkwCLcBGAsYHQ/s754/Khmer4Holiday.png')
		addDir('Korean',KHMER4+'search/label/Korea%20Drama?&max-results=24',101,'https://1.bp.blogspot.com/-9Y8PknwGtEE/YVp_qF4rR-I/AAAAAAAABAg/k4IED_8_o34L--XjAoMYZ6SwCKQgMZJkwCLcBGAsYHQ/s754/Khmer4Holiday.png')
		
		xbmcplugin.endOfDirectory(pluginhandle)	
		
### search using TVSROKKHMER & KHMERAVENUE site###
def SEARCH():
        keyb = xbmc.Keyboard('', 'Enter Search Text')
        keyb.doModal()
        if (keyb.isConfirmed()):
                searchText = urllib.quote_plus(keyb.getText())
        url = 'https://www.tvsrokkhmer.com/search?q='+ searchText
        SINDEX_TVSROKKHMER(url)
        url = 'https://www.khmeravenue.com/?s='+ searchText
        SINDEX_KHMERAVE(url)
        url = 'https://www.khmerdrama.com/?s='+ searchText
        SINDEX_KHMERAVE(url)		
# End search site		

# KhmerTv
def KHMERYV(url):
	link = dodge.channel(url)
	try:
		link =link.encode("UTF-8")
	except: pass
	match=re.compile("<title>(.+?)</title>\s*<link>(.+?)</link>\s*<thumbnail>(.+?)</thumbnail>").findall(link.decode('utf-8'))
	for vLinkName,vLink,vImage in match: 
		addLink(vLinkName,vLink,4,vImage)
		
# KhmerTV end


############## phumikhmer2 ****************** 
def INDEX_PHUMIK(url): 		
        html = OpenSoup(url)
        try:
            html =html.encode("UTF-8")
        except: pass
        soup = BeautifulSoup(html.decode('utf-8'))
        video_list = soup('div',{'class':'col-6 col-sm-4 col-md-3'})
        for link in video_list:
            vLink = BeautifulSoup(str(link))('a')[0]['href']
            vTitle = BeautifulSoup(str(link))('img')[0]['alt']
            vImage = BeautifulSoup(str(link))('img')[0]['src']
            addDir(vTitle,PHUMIK+vLink,95,PHUMIK+vImage)
        paging = soup.find(class_='pagination')
        for a in paging.find_all('a', href=True):
         pageurl = ( a['href'])
         pagenum = re.compile("&page=(.+)").findall(pageurl)[0] 
         addDir('Page ' + pagenum,PHUMIK+pageurl,91,"")

def EPISODE_PHUMIK(url,name):
    link = OpenURL(url)
    try:
        link = link.encode("UTF-8")
    except: pass
    soup = BeautifulSoup(link,"html.parser")
    data=re.compile('div class="col-lg-8 col-lg-8-9"(.+?)</script>').findall(link.decode("utf-8").replace('\n',''))[0]
    if 'options.player_list' in data:
        html=re.compile('options.player_list.+?\[(.+?)\].+?var player').findall(data)     
        for vid in html:
         match=re.compile('{\s*"file":\s*"(.+?)",\s*"title":\s*"(.+?)"').findall(vid.replace('\'','"'))    
         if(len(match) > 0):      
          for vLinks,vLinkName in match:                 
           addLink(vLinkName.replace(",",""),vLinks,4,'')

############## VIDEO4KHMER ****************** 
def INDEX_VIDEO4U(url):  
        html = OpenSoup(url)
        try:   
           html =html.encode("UTF-8")
        except: pass
        soup = BeautifulSoup(html, 'html.parser')
        div_index = soup('div',{'class':"cover-thumb"})
        for link in div_index:
            vLink = BeautifulSoup(str(link))('a')[0]['href']
            vTitle = BeautifulSoup(str(link))('a')[0]['title']
            vImage = BeautifulSoup(str(link))('div')[0]['style']
            addDir(vTitle,vLink,35,vImage.replace('background-image: url(',''))  
        match5=re.compile('<ul class="pagination mb-0">(.+?)</ul>').findall(html.decode('utf-8'))
        if(len(match5)):
           pages=re.compile('<a class=".+?" href="(.+?)">(.+?)</a>').findall(match5[0])
           for pageurl,pagenum in pages:
               addDir(" Page " + pagenum.replace("fas fa-angle-left","").replace("fas fa-angle-double-left","").replace("fas fa-angle-right","").replace("fas fa-angle-double-right","").replace("i class=","").replace("</i>","").replace("<","").replace(">","").replace("",""),pageurl,31,"")     
           xbmcplugin.endOfDirectory(pluginhandle)

def EPISODE_VIDEO4U(url,name):
    #try:
        link = OpenSoup(url)
        try:
            link =html.encode("UTF-8")
        except: pass
        newlink = ''.join(map(str,link.splitlines())).replace('\t','')
        soup = BeautifulSoup(newlink)
        listcontent=soup.findAll('div', {"class" : "row"})
        for item in listcontent[1].findAll('div', {"class" : "col-6 col-sm-4 cover-item"}):
            vname=item.a["title"]
            vname = vname.encode("UTF-8",'replace') 
            vurl=item.a["href"]
            addLink(vname,vurl,3,"")
        match5=re.compile('<ul class="pagination mb-0">(.+?)</ul>').findall(link.decode('utf-8'))
        if(len(match5)):
           pages=re.compile('<a class=".+?" href="(.+?)">(.+?)</a>').findall(match5[0])
           for pageurl,pagenum in pages:
               addDir(" Page " + pagenum.replace("fas fa-angle-left","").replace("fas fa-angle-double-left","").replace("fas fa-angle-right","").replace("fas fa-angle-double-right","").replace("i class=","").replace("</i>","").replace("<","").replace(">","").replace("",""),pageurl,35,"")     
           xbmcplugin.endOfDirectory(pluginhandle) 
           
############## TVSROKKHMER ****************** 
def INDEX_TVSROKKHMER(url): 		
         html = OpenSoup(url)
         try:
             html = html.encode("UTF-8")
         except: pass
         soup = BeautifulSoup(html, 'html.parser')
         div_index = soup('div',{"class":"entry-inner"})
         for link in div_index:
             vLink = BeautifulSoup(str(link))('a')[0]['href']
             vTitle = BeautifulSoup(str(link))('a')[0]['title']
             vImage = BeautifulSoup(str(link))('img')[0]['src']
             addDir(vTitle,vLink,75,vImage)
         pages=re.compile('<a class=\'blog-pager-older-link\' href=\'([^"]+?)\' id=\'.+?\' title=\'.+?\'').findall(html.decode('utf-8'))
         for pageurl in pages:
             addDir('NEXT PAGE', pageurl,71,"")  
         xbmcplugin.endOfDirectory(pluginhandle) 

def EPISODE_TVSROKKHMER(url,name):
    link = OpenURL(url)
    try:
        link = link.encode("UTF-8")
    except: pass
    soup = BeautifulSoup(link,"html.parser")
    data=re.compile('div id="main-player"(.+?)</script>').findall(link.decode("utf-8").replace('\n',''))[0]
    if 'options.player_list' in data:
        html=re.compile('options.player_list.+?\[(.+?)\].+?var player').findall(data)     
        for vid in html:
         match=re.compile('{\s*"file":\s*"(.+?)",\s*"title":\s*"(.+?)"').findall(vid.replace('\'','"'))    
         if(len(match) > 0):      
          for vLinks,vLinkName in match:                 
           addLink(vLinkName.replace(",",""),vLinks,4,'')  

# SEARCH 
def SINDEX_TVSROKKHMER(url): 		
         html = OpenSoup(url)
         try:
             html = html.encode("UTF-8")
         except: pass
         soup = BeautifulSoup(html, 'html.parser')
         div_index = soup('div',{"class":"entry-inner"})
         for link in div_index:
             vLink = BeautifulSoup(str(link))('a')[0]['href']
             vTitle = BeautifulSoup(str(link))('a')[0]['title']
             vImage = BeautifulSoup(str(link))('img')[0]['src']
             addDir(vTitle+'[COLOR red] TVSROKKHMER[/COLOR]',vLink,10,vImage)
# END SEARCH           


# Below uses mode==10		
############## KhmerAve SITE ****************** 		  
def INDEX_KHMERAVE(url):        
        html = OpenSoup(url)
        try:   
           html =html.encode("UTF-8")
        except: pass
        soup = BeautifulSoup(html, 'html.parser')
        div_index = soup('div',{'class':"col-6 col-sm-4 thumbnail-container"})
        for link in div_index:
            vLink = BeautifulSoup(str(link))('a')[0]['href']
            vTitle = BeautifulSoup(str(link))('h3')[0].contents[0].replace("&#8217;","")
            vTitle = vTitle.encode("UTF-8",'replace')
            vImage = BeautifulSoup(str(link))('div')[1]['style']
            vImage = re.findall('\((.+?)\)',vImage)[0]
            addDir(vTitle,vLink,10,vImage)
        match5=re.compile("<div class='wp-pagenavi' role='navigation'>\n(.+?)\n</div>").findall(html.decode('latin-1')) 
        if(len(match5)):
            pages=re.compile('<a class=".+?" title=".+?" href="(.+?)">(.+?)</a>').findall(match5[0])
            for pageurl,pagenum in pages:
             addDir(" Page " + pagenum,pageurl.encode("utf-8"),21,"")	

# SEARCH			 
def SINDEX_KHMERAVE(url):        
        html = OpenSoup(url)
        try:   
           html =html.encode("UTF-8")
        except: pass
        soup = BeautifulSoup(html, 'html.parser')
        div_index = soup('div',{'class':"col-6 col-sm-4 thumbnail-container"})
        for link in div_index:
            vLink = BeautifulSoup(str(link))('a')[0]['href']
            vTitle = BeautifulSoup(str(link))('h3')[0].contents[0].replace("&#8217;","")
            #vTitle = vTitle.encode("UTF-8",'replace')
            vImage = BeautifulSoup(str(link))('div')[1]['style']
            vImage = re.findall('\((.+?)\)',vImage)[0]
            addDir(vTitle+'[COLOR red] KHMERAVENUE[/COLOR]',vLink,10,vImage)		 
# END SEARCH
   
############## THEKOMSAN SITE ****************** 			   
def INDEX_THEKOMSAN(url):     
         html = OpenSoup(url)
         try:
             html = html.encode("UTF-8")
         except: pass
         soup = BeautifulSoup(html, 'html.parser')
         div_index = soup('div',{"class":"col-sm-4 portfolio-item"})
         for link in div_index:
             vLink = BeautifulSoup(str(link))('a')[0]['href']
             vTitle = BeautifulSoup(str(link))('img')[0]['alt']
             vTitle = vTitle.encode("UTF-8",'replace')
             vImage = BeautifulSoup(str(link))('img')[0]['src']
             print (vImage)
             addDir(vTitle,vLink,10,vImage)
         try:
           paging = soup('ul',{'class':'pagination'})
           pages = BeautifulSoup(str(paging[0]))('a')
           for p in pages:
             psoup = BeautifulSoup(str(p))
             pageurl = psoup('a')[0]['href']
             pagenum = psoup('a')[0].contents[0]
             addDir(" Page " + pagenum,(THEKOMSAN+ pageurl),41,"")		 
         except:pass

############## ckh7 SITE ****************** 
def INDEX_CKH7(url):
         html = OpenSoup(url)
         try:
             html = html.encode("UTF-8")
         except: pass
         soup = BeautifulSoup(html, features='html.parser')
         div_index = soup('div',{"class":"thumbnail"})
         for link in div_index:
             vLink = BeautifulSoup(str(link))('a')[0]['href']
             vTitle = BeautifulSoup(str(link))('img')[0]['alt']
             vImage = BeautifulSoup(str(link))('img')[0]['data-echo']
             #print (vImage)
             addDir(vTitle,vLink,10,vImage)
         try:
           paging = soup('ul',{'class':'pagination'})
           pages = BeautifulSoup(str(paging[0]))('a')
           for p in pages:
             psoup = BeautifulSoup(str(p))
             pageurl = psoup('a')[0]['href']
             pagenum = psoup('a')[0].contents[0]
             addDir(" Page " + pagenum,(CKH7+ pageurl),51,"")		 
         except:pass

############## PHUMI8 ****************** 
def INDEX_PHUMI8(url): 		
        html = OpenSoup(url)
        try:
            html =html.encode("UTF-8")
        except: pass
        soup = BeautifulSoup(html, 'html.parser')
        video_list = soup('div',{'class':'td-module-thumb'})
        for link in video_list:
            vLink = BeautifulSoup(str(link))('a')[0]['href']
            vTitle = BeautifulSoup(str(link))('a')[0]['title']
            vImage = BeautifulSoup(str(link))('img')[0]['src']
            addDir(vTitle,vLink,10,vImage)
        pagecontent=soup.findAll('div', {"class" : re.compile("page-nav*")})
        if(len(pagecontent)>0):
            for item in pagecontent[0].findAll('a', {"class" : ["page", "last"]}):
             addDir("Page " + item.contents[0],item["href"],61,"")


############## K8MERS ****************** 
def INDEX_K8MERS(url): 		
        html = OpenSoup(url)
        try:
            html =html.encode("UTF-8")
        except: pass
        soup = BeautifulSoup(html, 'html.parser')
        video_list = soup('a',{'class':'entry-image-wrap is-image'})
        for link in video_list:
            vLink = BeautifulSoup(str(link))('a')[0]['href']
            vTitle = BeautifulSoup(str(link))('a')[0]['title']
            vImage = BeautifulSoup(str(link))('span')[0]['data-image'].replace('s72-c','s1600')
            addDir(vTitle,vLink,10,vImage)
        pages=re.compile('<div class=\'blog-pager\' id=\'blog-pager\'>\n<a class=\'blog-pager-older-link load-more btn\' data-load=\'([^"]+?)\' ').findall(html.decode('utf-8'))
        for pageurl in pages:
             addDir('NEXT PAGE', pageurl,81,"")  
        xbmcplugin.endOfDirectory(pluginhandle) 
        
############## KHMER4HOLIDAY ****************** 
def INDEX_KHMER4(url):
  
        html = OpenSoup(url)
        try:
            html = html.encode("UTF-8")
        except: pass
        soup = BeautifulSoup(html.decode('utf-8'))
        video_list = soup('a',{'class':'entry-image-wrap is-image'})
        for link in video_list:
            vLink = BeautifulSoup(str(link))('a')[0]['href']
            vTitle = BeautifulSoup(str(link))('a')[0]['title']			
            vImage = BeautifulSoup(str(link))('span')[0]['data-src']
            addDir(vTitle,vLink,10,vImage)
        pages=re.compile('<div class=\'blog-pager\' id=\'blog-pager\'>\n<a class=\'blog-pager-older-link load-more btn\' data-load=\'([^"]+?)\' ').findall(html.decode('utf-8'))
        for pageurl in pages:
            addDir('NEXT PAGE',pageurl,101,"")		


# Use for all eposode player	mode==10
def EPISODE_PLAYERS(url,name):    
        link = OpenURL(url)
        try:
             link = link.encode("UTF-8")
        except: pass		
        match=re.compile('{\s*"file":\s*"(.+?)",\s*"title":\s*"(.+?)"').findall(link.decode("utf-8"))   #This section use for all video player
        if(len(match) > 0):      
         for vLink,vName in match:                 
          addLink(vName.replace("video 1",'Trailer'),vLink,4,'')

         else: # This use for KhmerAve/Melkon
          match=re.compile('<td><a href="(.+?)"><i class=".+?" style=".+?"></i>(.+?)</a></td>').findall(link.decode('utf-8'))   
          if(len(match) > 0): 		   
           for vLink,vName in reversed(match):                 
            addLink(vName.replace('Episode','Part'),vLink,3,'')	
			
          else:
           match=re.compile('<a class=".+?" style="margin: 5px 0;" href="(.+?)">(.+?)</a>').findall(link.decode('utf-8'))  
           if(len(match) > 0): 		   
            for vLink,vName in match:                 
             addLink(vName.encode("utf-8"),vLink,3,'')		


###################
		
def OpenXML(Doc):
    document = xml.dom.minidom.parseString(Doc)      
    items = document.getElementsByTagName('item')
    for itemXML in items:
     vname=itemXML.getElementsByTagName('title')[0].childNodes[0].data
     vpart=itemXML.getElementsByTagName('description')[0].childNodes[0].data
     vImage=itemXML.getElementsByTagName('jwplayer:image')[0].childNodes[0].data
     vurl=itemXML.getElementsByTagName('jwplayer:source')[0].getAttribute('file')     
     addLink(vpart.encode("utf-8"),vurl.encode("utf-8"),4,"")           

def VIDEOLINKS(url):              
           link=OpenSoup(url)
           url = re.compile('Base64.decode\("(.+?)"\)').findall(link.decode('utf-8'))
           if(len(url) > 0):
            host=url[0].decode('base-64')
            match=re.compile('<iframe frameborder="0" [^>]*src="(.+?)"[^>]*>').findall(host)[0]
            VIDEO_HOSTING(match)
            #Play_VIDEO(match)
           else:
            match=re.compile('"file": "(.+?)"').findall(link.decode('utf-8'))
            #match=re.compile('<IFRAME SRC="\r\n(.+?)" [^>]*').findall(link)
            if(len(match) == 0):
             match=re.compile('file:\s*"([^"]+?)"').findall(link.decode('utf-8'))# Good Link
             if(len(match) == 0):
              match=re.compile('<iframe src="(.+?)" class="video allowfullscreen="true">').findall(link.decode('utf-8'))
              if(len(match) == 0):
                match=re.compile('<iframe frameborder="0" [^>]*src="(.+?)">').findall(link.decode('utf-8'))
                if(len(match)==0):
                 match=re.compile('<IFRAME SRC="(.+?)" [^>]*').findall(link.decode('utf-8'))
                 if(len(match) == 0):   
                   #match=re.compile('<iframe [^>]*src="(.+?)" [^>]*').findall(link)
                   match=re.compile("'file': '(.+?)',").findall(link.decode('utf-8'))
                   if(len(match) == 0):
                    match=re.compile('<div class="video_main">\s*<iframe [^>]*src=["\']?([^>^"^\']+)["\']?[^>]*>').findall(link.decode('utf-8'))
                    if(len(match) == 0):
                     match = re.compile("var flashvars = {file: '(.+?)',").findall(link.decode('utf-8'))        
                     if(len(match) == 0):       
                      match = re.compile('swfobject\.embedSWF\("(.+?)",').findall(link.decode('utf-8'))
                      if(len(match) == 0):
                       match = re.compile("'file':\s*'(.+?)'").findall(link.decode('utf-8'))
                       if(len(match) == 0):
                        match = re.compile("file: '(.+?)'").findall(link.decode('utf-8'))
                        if(len(match) == 0):
                         match = re.compile('src="(.+?)" frameborder="0"').findall(link.decode('utf-8'))
                         if(len(match) == 0):                    
                          match = re.compile('<iframe [^>]*src=["\']?([^>^"^\']+)["\']?[^>]*>').findall(link.decode('utf-8'))
                          if(len(match)== 0):
                           match = re.compile('<source [^>]*src="([^"]+?)"').findall(link.decode('utf-8'))
                           if(len(match) == 0):   
                            match=re.compile('playlist: "(.+?)"').findall(link)# Good Link
                            if(len(match) == 0):
                             match=re.compile('<!\[CDATA\[(.*?)\]\]></tvurl>').findall(link)# KhmerTV
                             if(len(match) == 0):							
                              #match = re.compile('<iframe[^<]+src="(.+?)"').findall(link.replace('=m37','=m18')) 
                              #if(len(match) == 0): 							 
                               match = re.compile('<script>\nvidId = \'(.+?)\'; \n</script>').findall(link)
                               for url in match:
                                vid = url[0].replace("['']", "")       
                                match ='https://docs.google.com/file/d/'+ (vid)+'/preview'
                                #REAL_VIDEO_HOST(match)
                                VIDEO_HOSTING(match)
                                print (match)
           VIDEO_HOSTING(match[0])
           print (match)
           xbmcplugin.endOfDirectory(pluginhandle)
		   
def OpenNET(url):
    try:
       net = Net(cookie_file=cookiejar)
       #net = Net(cookiejar)
       try:
            second_response = net.http_GET(url)
       except:
            second_response = net.http_GET(url.encode("utf-8"))
       return second_response.content
    except:
       d = xbmcgui.Dialog()
       d.ok(url,"Can't Connect to site",'Try again in a moment')		   

def VIDEO_HOSTING(vlink):
           if 'khmotions.com' in vlink:   
                VideoURL = KHMOTIONS(vlink)
                print (('VideoURL: %s' % VideoURL))
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Khmotion Loading selected video)")
                Play_VIDEO(VideoURL)	

           elif 'kolabkhmer.club' in vlink:
                VideoURL = KOLABKHMERS(vlink)
                print (('VideoURL: %s' % VideoURL))
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Kolabkhmer Loading selected video)")
                Play_VIDEO(VideoURL)
				
           elif 'kolabkhmer.html' in vlink:                   
                VideoURL = KHMER7(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Khmer7 Loading selected video)")
                Play_VIDEO(VideoURL)				
				
           elif 'dailymotion.com' in vlink:                
                VideoURL = DAILYMOTION(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Dailymotion Loading selected video)")
                Play_VIDEO(VideoURL)	

           elif 'estream.to' in vlink:   
                VideoURL = ESTREAM(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Estream Loading selected video)")
                Play_VIDEO(VideoURL)				
				
           elif 'facebook.com' in vlink:   
                VideoURL = FACEBOOK(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Facebook Loading selected video)")
                Play_VIDEO(VideoURL)	

           elif 'fembed.com' in vlink:
                VideoURL = FEMBED(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Fembed Loading selected video)")
                Play_VIDEO(VideoURL)

           elif 'google.com' in vlink:   
                VideoURL = GOOGLE(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Google Loading selected video)")
                Play_VIDEO(VideoURL)	

           elif 'k-vid.net' in vlink:   
                VideoURL = KVID(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,K-vid Loading selected video)")
                Play_VIDEO(VideoURL)
				
           elif 'movie-khmer.com' in vlink:   
                VideoURL = MOVIEKHMER(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Subkh Loading selected video)")
                Play_VIDEO(VideoURL)				

           elif 'mp4upload.com' in vlink:
                VideoURL = MP4UPLOAD(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Mp4upload Loading selected video)")
                Play_VIDEO(VideoURL)				
		
           elif 'ok.ru' in vlink:
                VideoURL = OKRU(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,OK Loading selected video)")
                Play_VIDEO(VideoURL)	
				
           elif 'openload.co' in vlink:   
                VideoURL = OPENLOAD(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Openload Loading selected video)")
                Play_VIDEO(VideoURL)				
				
           elif 'rapidvideo.com' in vlink:   
                VideoURL = RAPIDVIDEOCOM(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Rapidvideo Loading selected video)")
                Play_VIDEO(VideoURL)				

           elif 'streamango.com' in vlink:   
                VideoURL = STREAMANGO(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Streamango Loading selected video)")
                Play_VIDEO(VideoURL)		
				
           elif 'subkh.com' in vlink:   
                VideoURL = SUBKH(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Subkh Loading selected video)")
                Play_VIDEO(VideoURL)				

           elif 'vev.io' in vlink:   
                VideoURL = VEVIO(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Vevio Loading selected video)")
                Play_VIDEO(VideoURL)				
     
           elif 'vimeo.com' in vlink:
                 VideoURL = VIMEO(vlink)
                 print ('VideoURL: %s' % VideoURL)
                 #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Vimeo Loading selected video)")
                 Play_VIDEO(VideoURL)
				 
           elif 'vidlox.me' in vlink:
                 VideoURL = VIDLOX(vlink)
                 print ('VideoURL: %s' % VideoURL)
                 #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Vidlox Loading selected video)")
                 Play_VIDEO(VideoURL)	

           elif 'xstreamcdn.com' in vlink:
                 VideoURL = XSTREAMCDN(vlink)
                 print ('VideoURL: %s' % VideoURL)
                 #xbmc.executebuiltin("XBMC.Notification(Please Wait!,xStreamcdn Loading selected video)")
                 Play_VIDEO(VideoURL)				 

           elif 'youtube.com' in vlink:                   
                VideoURL = YOUTUBE(vlink)
                print ('VideoURL: %s' % VideoURL)
                #xbmc.executebuiltin("XBMC.Notification(Please Wait!,Youtube Loading selected video)")
                Play_VIDEO(VideoURL)        
       
           else:
                print ('VideoURL: %s' % vlink)
                xbmc.executebuiltin("XBMC.Notification(Please Wait!, KonJen is loading...)")
                Play_VIDEO(urllib2.unquote(vlink))
                #VideoURL = urlresolver.HostedMediaFile(url=vlink).resolve()
                #Play_VIDEO(VideoURL)

def Play_VIDEO(VideoURL):

    print ('PLAY VIDEO: %s' % VideoURL)    
    item = xbmcgui.ListItem(path=VideoURL)
    return xbmcplugin.setResolvedUrl(pluginhandle, True, item)

###################### Resolver Start  ###################
def GetContent2(url,referr, cj):
    if cj is None:
        cj = cookielib.LWPCookieJar()
    opener = urllib2.build_opener(urllib2.HTTPCookieProcessor(cj))
    opener.addheaders = [(
        'Accept', 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'),
        ('Accept-Encoding', 'gzip, deflate'),
        ('Referer', referr),
        ('Content-Type', 'application/x-www-form-urlencoded'),
        ('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:13.0) Gecko/20100101 Firefox/13.0'),
        ('Connection', 'keep-alive'),
        ('Accept-Language', 'en-us,en;q=0.5'),
        ('Pragma', 'no-cache')]
    usock = opener.open(url)
    if usock.info().get('Content-Encoding') == 'gzip':
        buf = StringIO.StringIO(usock.read())
        f = gzip.GzipFile(fileobj=buf)
        response = f.read()
    else:
        response = usock.read()
    usock.close()
    return (cj, response)
	
def KHMOTIONS(SID):
	req = urllib2.Request(SID)
	req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/28.0.1500.72 Safari/537.3')
	response = urllib2.urlopen(req)
	link=response.read()
	response.close()    
	match720p = re.compile('file:\s"(.+?)",.+?720.+?"', re.DOTALL).findall(link)
	match480p = re.compile('file:\s"(.+?)",.+?480.+?"', re.DOTALL).findall(link)
	match360p = re.compile('file:\s"(.+?)",.+?360.+?"', re.DOTALL).findall(link)
	match240p = re.compile('file:\s"(.+?)",.+?240.+?"', re.DOTALL).findall(link)
	matchSD = re.compile('file : "(.+?)"', re.DOTALL).findall(link)
	if match720p:
		VideoURL = urllib.unquote_plus(match720p[0])
	elif match480p:
		VideoURL = urllib.unquote_plus(match480p[0])
	elif match360p:
		VideoURL = urllib.unquote_plus(match360p[0])
	elif match240p:
		VideoURL = urllib.unquote_plus(match240p[0])
	elif matchSD:
		VideoURL = matchSD[0]
	return VideoURL			

def KOLABKHMERS(SID):
        VID = urllib2.unquote(SID).replace("//", "http://")
        req = urllib2.Request(VID)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/28.0.1500.72 Safari/537.3')
        response = urllib2.urlopen(req)
        link=response.read()
        response.close()
        VideoURL =  re.compile('"file":"(.+?)"').findall(link.replace('\/','/'))[0]
        return VideoURL	
		
def KHMER7(SID):
	media_id =re.compile("slug=(.+?)&").findall(SID)[0]
	headers = {'Referer': 'https://www.kolabkhmer.com/kolabkhmer.html', 'User-Agent': 'Mozilla/5.0 (Linux; Android 4.4.2; Nexus 4 Build/KOT49H) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/34.0.1847.114 Mobile Safari/537.36'}
	link = requests.get(SID, headers=headers).content
	key= re.compile('key: "(.+?)",').findall(link)[0]
	data = {'key':key,'type':'slug','value':media_id,'dataType':'m3u8'}
	url2 = requests.post("https://multi.idocdn.com/vip", data=data).content
	vid = re.compile('"link":"(.+?)",').findall(url2)[0]
	origin = 'https://www.kolabkhmer.com'
	VideoURL = get_link(vid, origin)
	return VideoURL			

def DAILYMOTION(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL 
		
def ESTREAM(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL		

def FACEBOOK(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL	

def FEMBED(Video_ID):
	media_id = re.compile("fembed.com/v/(.+)").findall(Video_ID)[0]
	SID = 'https://www.fembed.com/api/source/%s' % media_id
	link = requests.post(SID).content
	match720p = re.compile('"file":"(.+?)".+?"720p"', re.DOTALL).findall(link)
	match480p = re.compile('"file":"(.+?)".+?"480p"', re.DOTALL).findall(link)
	match360p = re.compile('"file":"(.+?)".+?"360p"', re.DOTALL).findall(link)
	match240p = re.compile('"file":"(.+?)".+?"240p"', re.DOTALL).findall(link)
	if match720p:
		VideoURL = urllib.unquote_plus(match720p[0])
	elif match480p:
		VideoURL = urllib.unquote_plus(match480p[0])
	elif match360p:
		VideoURL = urllib.unquote_plus(match360p[0])
	elif match240p:
		VideoURL = urllib.unquote_plus(match240p[0])
	return VideoURL.replace('\/','/')

def GOOGLE(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL 

def KVID(SID):
		link = OpenURL(SID)
		URL=re.compile('window.location = "(.+?)"').findall(link)[0]
		VideoURL = resolveurl.resolve(URL)
		return VideoURL	
		
def MOVIEKHMER(SID):
	headers = {'Referer': 'https://movie-khmer.com', 'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/83.0.4103.61 Safari/537.36'}
	link = requests.get('https:'+SID, headers=headers).content 
	VideoURL=re.compile('file:"(.+?)"').findall(link)[0]
	headers.update({'verifypeer': 'false'})
	return VideoURL+'|'+urlencode(headers)			

def MP4UPLOAD(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL 		
		
def OKRU(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL 

def OPENLOAD(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL			

def RAPIDVIDEOCOM(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL 
		
def STREAMANGO(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL 
		
def VEVIO(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL  		
		
def VIDLOX(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL 		
		
def VIMEO(Video_ID):
        #pickle_in = open(dpath+"dict.pickle","rb")
        #referer = pickle.load(pickle_in)
        #Referer = (referer[1])
        HomeURL = ("http://"+Video_ID.split('/')[2])
        if 'player' in Video_ID:
            media_id =re.compile("//player.vimeo.com/video/(.+?)\?").findall(Video_ID+'?')
        elif 'vimeo' in Video_ID:
              media_id =re.compile("//vimeo.com/(.+)").findall(Video_ID+'?')
        SID = "https://player.vimeo.com/video/%s?api=1&amp;player_id=video_player" % media_id[0]  
        headers = {'Referer': Referer}
        link = requests.get(SID, headers=headers)
        VideoURL = re.compile('"hls"[^>]*"akfire_interconnect_quic":{"url":"(.+?)"').findall(link.content)[0]
        return VideoURL	
		
def XSTREAMCDN(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL		
	
def YOUTUBE(SID):
        VideoURL = resolveurl.resolve(SID)
        return VideoURL  
	
###################### Resolver End  ###################    

def addLink(name,url,mode,iconimage):
		u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
		ok=True
		liz=xbmcgui.ListItem(name)
		liz.setArt({'poster': iconimage})
		liz.setArt({'icon': iconimage})
		liz.setInfo( type="Video", infoLabels={ "Title": name } )
		liz.setProperty("IsPlayable","true")
		contextMenuItems = []
		liz.addContextMenuItems(contextMenuItems, replaceItems=True)
		ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz)
		return ok		
		
def addDir(name,url,mode,iconimage):
		u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)
		ok=True
		liz=xbmcgui.ListItem(name)
		liz.setArt({'poster': iconimage})
		liz.setArt({'icon': iconimage})
		liz.setInfo( type="Video", infoLabels={ "Title": name } )
		ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
		return ok	

def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2:
                params=sys.argv[2]
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param    

params=get_params()
url=None
name=None
mode=None
play=None
try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        mode=int(params["mode"])
except:
        pass	
		
sysarg=str(sys.argv[1]) 
if mode==None or url==None or len(url)<1:
        #OtherContent()
        HOME()
elif mode==3:
        VIDEOLINKS(url)
elif mode==4:
        VIDEO_HOSTING(url)        
elif mode==5:
        SEARCH()	
elif mode==6:
        PlayURL(url)	
	
elif mode==11:
        KHMERYV(url) # For KhmerTV

# Use of mode ==10	
elif mode==10:
        EPISODE_PLAYERS(url,name) # Use for all eposode player	
		
elif mode==21:
        INDEX_KHMERAVE(url)			
elif mode==41:		
        INDEX_THEKOMSAN(url)
elif mode==51:		
        INDEX_CKH7(url)
elif mode==61:		
        INDEX_PHUMI8(url)
elif mode==81:			
        INDEX_K8MERS(url)
		
# Other video w/out mode=10
elif mode==31:
        INDEX_VIDEO4U(url)    
elif mode==35:
        EPISODE_VIDEO4U(url,name)	
elif mode==71:		
        INDEX_TVSROKKHMER(url)
elif mode ==75:        
        EPISODE_TVSROKKHMER(url,name)        
elif mode==91:
        INDEX_PHUMIK(url)
elif mode==95:
        EPISODE_PHUMIK(url,name)		
elif mode==101:
        INDEX_KHMER4(url)			
	
       
xbmcplugin.endOfDirectory(int(sysarg))